import {
    Scene,
    PerspectiveCamera,
    BoxGeometry,
    MeshBasicMaterial,
    Mesh,
    CylinderGeometry,
    WebGLRenderer,
    TextureLoader
} from "three";
import {mergeBufferGeometries} from 'three/examples/jsm/utils/BufferGeometryUtils.js';

const loadTexture = async () => new Promise(
    resolve => new TextureLoader().load('texture.jpg', resolve, undefined, console.log));
(async _ => {
    const scene = new Scene(),
        renderer = new WebGLRenderer({antialias: true}),
        camera = new PerspectiveCamera(50, window.innerWidth / window.innerHeight, 1, 10000),
        texture = await loadTexture(),
        material = new MeshBasicMaterial({map: texture}),
        angle = Math.PI * 0.5,
        geo1 = new BoxGeometry(100, 300, 8),
        geo2 = new BoxGeometry(100, 200, 8),
        circle = new CylinderGeometry(100, 100, 8, 64,
            1, false, -angle, angle);
    camera.position.z = 500;
    geo2.translate(-100, 50, 0);
    circle.rotateX(angle);
    circle.translate(-50, -50, 0);
    const geo = mergeBufferGeometries([geo1, geo2, circle]),
        mesh = new Mesh(geo, material);
    scene.add(mesh);
    renderer.setClearColor(0xffffff);
    renderer.setSize(window.innerWidth, window.innerHeight);
    renderer.setAnimationLoop(animation);
    document.body.appendChild(renderer.domElement);

    function animation() {
        mesh.rotation.x += 0.003;
        mesh.rotation.y += 0.006;
        renderer.render(scene, camera);
    }
})();
